 processor 6502
	ORG $801
	.byte    $0E, $08, $0A, $00, $9E, $20, $28
	.byte   $32,$30,$36,$34
	.byte    $29, $00, $00, $00
	ORG $810
Full_screen_char_compression
	jmp block1
sp	= $02
frame	dc.b	$00
time	dc.b	$00
	
	
	; ***********  Defining procedure : init16x8mul
	;    Procedure type : Built-in function
	;    Requires initialization : no
	
mul16x8_num1Hi = $4c
mul16x8_num1 = $4e
mul16x8_num2 = $50
mul16x8_procedure
	lda #$00
	ldy #$00
	beq mul16x8_enterLoop
mul16x8_doAdd
	clc
	adc mul16x8_num1
	tax
	tya
	adc mul16x8_num1Hi
	tay
	txa
mul16x8_loop
	asl mul16x8_num1
	rol mul16x8_num1Hi
mul16x8_enterLoop  ; accumulating multiply entry point (enter with .A=lo, .Y=hi)
	lsr mul16x8_num2
	bcs mul16x8_doAdd
	bne mul16x8_loop
	rts
	
	
	; ***********  Defining procedure : initeightbitmul
	;    Procedure type : Built-in function
	;    Requires initialization : no
	
multiplier = $4c
multiplier_a = $4e
multiply_eightbit
	cpx #$00
	beq mul_end
	dex
	stx $4e
	lsr
	sta multiplier
	lda #$00
	ldx #$08
mul_loop
	bcc mul_skip
mul_mod
	adc multiplier_a
mul_skip
	ror
	ror multiplier
	dex
	bne mul_loop
	ldx multiplier
	rts
mul_end
	txa
	rts
initeightbitmul_multiply_eightbit2
	rts
	
; //text : string=("         OFFENCE     JEG HAR TISS    HAR DU TISS KANSKJE     ",0,"         ");
 ; Temp vars section
 ; Temp vars section ends
	
	
	; ***********  Defining procedure : Raster
	;    Procedure type : User-defined procedure
	
Raster
	; StartIRQ
	pha
	txa
	pha
	tya
	pha
	asl $d019
	inc time
	; Binary clause Simplified: EQUALS
	; 8 bit binop
	; Add/sub where right value is constant number
	lda time
	and #1
	 ; end add / sub var with constant
	
	; Compare with pure num / var optimization
	cmp #$0;keep
	bne Raster_elsedoneblock41
Raster_ConditionalTrueBlock39
	jsr UpdateFrame
Raster_elseblock40
Raster_elsedoneblock41
	; CloseIRQ
	pla
	tay
	pla
	tax
	pla
	rti
block1
	; Assigning single variable : sp
	lda #<screens1
	ldx #>screens1
	sta sp
	stx sp+1
	; Set bank
	lda #2
	sta $dd00
	; Multicolor mode
	lda #16
	ora $d016
	sta $d016
	; Assigning memory location
	; Assigning single variable : $d020
	lda #0
	sta $d020
	; Assigning memory location
	; Assigning single variable : $d021
	sta $d021
	; Assigning single variable : $d021
	; Store Variable simplified optimization : right-hand term is pure
	ldx #1 ; optimized, look out for bugs
	lda #3
	sta $d021,x
	; Assigning single variable : $d021
	; Store Variable simplified optimization : right-hand term is pure
	ldx #2 ; optimized, look out for bugs
	lda #6
	sta $d021,x
	; Clear screen with offset
	lda #12
	ldx #$fa
MainProgram_clearloop44
	dex
	sta $0000+$d800,x
	sta $00fa+$d800,x
	sta $01f4+$d800,x
	sta $02ee+$d800,x
	bne MainProgram_clearloop44
	lda $d018
	and #%11110001
	ora #4
	sta $d018
	; Disable interrupts
	ldy #$7f    ; $7f = %01111111
	sty $dc0d   ; Turn off CIAs Timer interrupts
	sty $dd0d   ; Turn off CIAs Timer interrupts
	
	; Set Memory Config
	lda $01
	and #%11111000
	ora #%101
	sta $01
	sei
	; Disable interrupts
	sty $dc0d   ; Turn off CIAs Timer interrupts
	sty $dd0d   ; Turn off CIAs Timer interrupts
	
	; RasterIRQ : Hook a procedure
	lda #0
	sta $d012
	lda #<Raster
	sta $fffe
	lda #>Raster
	sta $ffff
	; Enable raster IRQ
	lda $d01a
	ora #$01
	sta $d01a
	lda #$1B
	sta $d011
	asl $d019
	cli
	jmp * ; loop like (?/%
EndSymbol
	org $1770
screens1
	incbin "C:/Users/leuat/Documents/GitHub/TRSE/Release/tutorials/C64/DemoEffects_raytracer///data/13_screen0.bin"
	org $1f40
screens2
	incbin "C:/Users/leuat/Documents/GitHub/TRSE/Release/tutorials/C64/DemoEffects_raytracer///data/13_screen1.bin"
	org $2710
screens3
	incbin "C:/Users/leuat/Documents/GitHub/TRSE/Release/tutorials/C64/DemoEffects_raytracer///data/13_screen2.bin"
	org $2ee0
screens4
	incbin "C:/Users/leuat/Documents/GitHub/TRSE/Release/tutorials/C64/DemoEffects_raytracer///data/13_screen3.bin"
	org $5000
charset1
	incbin "C:/Users/leuat/Documents/GitHub/TRSE/Release/tutorials/C64/DemoEffects_raytracer///data/13_charset0.bin"
	org $5800
charset2
	incbin "C:/Users/leuat/Documents/GitHub/TRSE/Release/tutorials/C64/DemoEffects_raytracer///data/13_charset1.bin"
	org $6000
charset3
	incbin "C:/Users/leuat/Documents/GitHub/TRSE/Release/tutorials/C64/DemoEffects_raytracer///data/13_charset2.bin"
	org $6800
charset4
	incbin "C:/Users/leuat/Documents/GitHub/TRSE/Release/tutorials/C64/DemoEffects_raytracer///data/13_charset3.bin"
	org $8000
	
	
	; ***********  Defining procedure : UpdateFrame
	;    Procedure type : User-defined procedure
	
UpdateFrame
	; Binary clause Simplified: EQUALS
	lda frame
	; Compare with pure num / var optimization
	cmp #$6;keep
	bne UpdateFrame_elsedoneblock7
UpdateFrame_ConditionalTrueBlock5
	
; // For each frame, simply set the 
; // character set. In this example, 2 images are contained in 1 character set
	lda $d018
	and #%11110001
	ora #10
	sta $d018
UpdateFrame_elseblock6
UpdateFrame_elsedoneblock7
	; Binary clause Simplified: EQUALS
	lda frame
	; Compare with pure num / var optimization
	cmp #$4;keep
	bne UpdateFrame_elsedoneblock13
UpdateFrame_ConditionalTrueBlock11
	
; // 2x frames
	lda $d018
	and #%11110001
	ora #8
	sta $d018
UpdateFrame_elseblock12
UpdateFrame_elsedoneblock13
	; Binary clause Simplified: EQUALS
	lda frame
	; Compare with pure num / var optimization
	cmp #$2;keep
	bne UpdateFrame_elsedoneblock19
UpdateFrame_ConditionalTrueBlock17
	
; // 2x frames
	lda $d018
	and #%11110001
	ora #6
	sta $d018
UpdateFrame_elseblock18
UpdateFrame_elsedoneblock19
	; Binary clause Simplified: EQUALS
	lda frame
	; Compare with pure num / var optimization
	cmp #$0;keep
	bne UpdateFrame_elsedoneblock25
UpdateFrame_ConditionalTrueBlock23
	
; // 2x frames
	lda $d018
	and #%11110001
	ora #4
	sta $d018
UpdateFrame_elseblock24
UpdateFrame_elsedoneblock25
	
; // 2x frames
; // FAST full-screen copying using unrolled loops
	; memcpy unrolled
	ldy #0
	lda (sp),y
	sta $4400 +  #$00
	ldy #1
	lda (sp),y
	sta $4400 +  #$01
	ldy #2
	lda (sp),y
	sta $4400 +  #$02
	ldy #3
	lda (sp),y
	sta $4400 +  #$03
	ldy #4
	lda (sp),y
	sta $4400 +  #$04
	ldy #5
	lda (sp),y
	sta $4400 +  #$05
	ldy #6
	lda (sp),y
	sta $4400 +  #$06
	ldy #7
	lda (sp),y
	sta $4400 +  #$07
	ldy #8
	lda (sp),y
	sta $4400 +  #$08
	ldy #9
	lda (sp),y
	sta $4400 +  #$09
	ldy #10
	lda (sp),y
	sta $4400 +  #$0a
	ldy #11
	lda (sp),y
	sta $4400 +  #$0b
	ldy #12
	lda (sp),y
	sta $4400 +  #$0c
	ldy #13
	lda (sp),y
	sta $4400 +  #$0d
	ldy #14
	lda (sp),y
	sta $4400 +  #$0e
	ldy #15
	lda (sp),y
	sta $4400 +  #$0f
	ldy #16
	lda (sp),y
	sta $4400 +  #$10
	ldy #17
	lda (sp),y
	sta $4400 +  #$11
	ldy #18
	lda (sp),y
	sta $4400 +  #$12
	ldy #19
	lda (sp),y
	sta $4400 +  #$13
	ldy #20
	lda (sp),y
	sta $4400 +  #$14
	ldy #21
	lda (sp),y
	sta $4400 +  #$15
	ldy #22
	lda (sp),y
	sta $4400 +  #$16
	ldy #23
	lda (sp),y
	sta $4400 +  #$17
	ldy #24
	lda (sp),y
	sta $4400 +  #$18
	ldy #25
	lda (sp),y
	sta $4400 +  #$19
	ldy #26
	lda (sp),y
	sta $4400 +  #$1a
	ldy #27
	lda (sp),y
	sta $4400 +  #$1b
	ldy #28
	lda (sp),y
	sta $4400 +  #$1c
	ldy #29
	lda (sp),y
	sta $4400 +  #$1d
	ldy #30
	lda (sp),y
	sta $4400 +  #$1e
	ldy #31
	lda (sp),y
	sta $4400 +  #$1f
	ldy #32
	lda (sp),y
	sta $4400 +  #$20
	ldy #33
	lda (sp),y
	sta $4400 +  #$21
	ldy #34
	lda (sp),y
	sta $4400 +  #$22
	ldy #35
	lda (sp),y
	sta $4400 +  #$23
	ldy #36
	lda (sp),y
	sta $4400 +  #$24
	ldy #37
	lda (sp),y
	sta $4400 +  #$25
	ldy #38
	lda (sp),y
	sta $4400 +  #$26
	ldy #39
	lda (sp),y
	sta $4400 +  #$27
	ldy #40
	lda (sp),y
	sta $4400 +  #$28
	ldy #41
	lda (sp),y
	sta $4400 +  #$29
	ldy #42
	lda (sp),y
	sta $4400 +  #$2a
	ldy #43
	lda (sp),y
	sta $4400 +  #$2b
	ldy #44
	lda (sp),y
	sta $4400 +  #$2c
	ldy #45
	lda (sp),y
	sta $4400 +  #$2d
	ldy #46
	lda (sp),y
	sta $4400 +  #$2e
	ldy #47
	lda (sp),y
	sta $4400 +  #$2f
	ldy #48
	lda (sp),y
	sta $4400 +  #$30
	ldy #49
	lda (sp),y
	sta $4400 +  #$31
	ldy #50
	lda (sp),y
	sta $4400 +  #$32
	ldy #51
	lda (sp),y
	sta $4400 +  #$33
	ldy #52
	lda (sp),y
	sta $4400 +  #$34
	ldy #53
	lda (sp),y
	sta $4400 +  #$35
	ldy #54
	lda (sp),y
	sta $4400 +  #$36
	ldy #55
	lda (sp),y
	sta $4400 +  #$37
	ldy #56
	lda (sp),y
	sta $4400 +  #$38
	ldy #57
	lda (sp),y
	sta $4400 +  #$39
	ldy #58
	lda (sp),y
	sta $4400 +  #$3a
	ldy #59
	lda (sp),y
	sta $4400 +  #$3b
	ldy #60
	lda (sp),y
	sta $4400 +  #$3c
	ldy #61
	lda (sp),y
	sta $4400 +  #$3d
	ldy #62
	lda (sp),y
	sta $4400 +  #$3e
	ldy #63
	lda (sp),y
	sta $4400 +  #$3f
	ldy #64
	lda (sp),y
	sta $4400 +  #$40
	ldy #65
	lda (sp),y
	sta $4400 +  #$41
	ldy #66
	lda (sp),y
	sta $4400 +  #$42
	ldy #67
	lda (sp),y
	sta $4400 +  #$43
	ldy #68
	lda (sp),y
	sta $4400 +  #$44
	ldy #69
	lda (sp),y
	sta $4400 +  #$45
	ldy #70
	lda (sp),y
	sta $4400 +  #$46
	ldy #71
	lda (sp),y
	sta $4400 +  #$47
	ldy #72
	lda (sp),y
	sta $4400 +  #$48
	ldy #73
	lda (sp),y
	sta $4400 +  #$49
	ldy #74
	lda (sp),y
	sta $4400 +  #$4a
	ldy #75
	lda (sp),y
	sta $4400 +  #$4b
	ldy #76
	lda (sp),y
	sta $4400 +  #$4c
	ldy #77
	lda (sp),y
	sta $4400 +  #$4d
	ldy #78
	lda (sp),y
	sta $4400 +  #$4e
	ldy #79
	lda (sp),y
	sta $4400 +  #$4f
	ldy #80
	lda (sp),y
	sta $4400 +  #$50
	ldy #81
	lda (sp),y
	sta $4400 +  #$51
	ldy #82
	lda (sp),y
	sta $4400 +  #$52
	ldy #83
	lda (sp),y
	sta $4400 +  #$53
	ldy #84
	lda (sp),y
	sta $4400 +  #$54
	ldy #85
	lda (sp),y
	sta $4400 +  #$55
	ldy #86
	lda (sp),y
	sta $4400 +  #$56
	ldy #87
	lda (sp),y
	sta $4400 +  #$57
	ldy #88
	lda (sp),y
	sta $4400 +  #$58
	ldy #89
	lda (sp),y
	sta $4400 +  #$59
	ldy #90
	lda (sp),y
	sta $4400 +  #$5a
	ldy #91
	lda (sp),y
	sta $4400 +  #$5b
	ldy #92
	lda (sp),y
	sta $4400 +  #$5c
	ldy #93
	lda (sp),y
	sta $4400 +  #$5d
	ldy #94
	lda (sp),y
	sta $4400 +  #$5e
	ldy #95
	lda (sp),y
	sta $4400 +  #$5f
	ldy #96
	lda (sp),y
	sta $4400 +  #$60
	ldy #97
	lda (sp),y
	sta $4400 +  #$61
	ldy #98
	lda (sp),y
	sta $4400 +  #$62
	ldy #99
	lda (sp),y
	sta $4400 +  #$63
	ldy #100
	lda (sp),y
	sta $4400 +  #$64
	ldy #101
	lda (sp),y
	sta $4400 +  #$65
	ldy #102
	lda (sp),y
	sta $4400 +  #$66
	ldy #103
	lda (sp),y
	sta $4400 +  #$67
	ldy #104
	lda (sp),y
	sta $4400 +  #$68
	ldy #105
	lda (sp),y
	sta $4400 +  #$69
	ldy #106
	lda (sp),y
	sta $4400 +  #$6a
	ldy #107
	lda (sp),y
	sta $4400 +  #$6b
	ldy #108
	lda (sp),y
	sta $4400 +  #$6c
	ldy #109
	lda (sp),y
	sta $4400 +  #$6d
	ldy #110
	lda (sp),y
	sta $4400 +  #$6e
	ldy #111
	lda (sp),y
	sta $4400 +  #$6f
	ldy #112
	lda (sp),y
	sta $4400 +  #$70
	ldy #113
	lda (sp),y
	sta $4400 +  #$71
	ldy #114
	lda (sp),y
	sta $4400 +  #$72
	ldy #115
	lda (sp),y
	sta $4400 +  #$73
	ldy #116
	lda (sp),y
	sta $4400 +  #$74
	ldy #117
	lda (sp),y
	sta $4400 +  #$75
	ldy #118
	lda (sp),y
	sta $4400 +  #$76
	ldy #119
	lda (sp),y
	sta $4400 +  #$77
	ldy #120
	lda (sp),y
	sta $4400 +  #$78
	ldy #121
	lda (sp),y
	sta $4400 +  #$79
	ldy #122
	lda (sp),y
	sta $4400 +  #$7a
	ldy #123
	lda (sp),y
	sta $4400 +  #$7b
	ldy #124
	lda (sp),y
	sta $4400 +  #$7c
	ldy #125
	lda (sp),y
	sta $4400 +  #$7d
	ldy #126
	lda (sp),y
	sta $4400 +  #$7e
	ldy #127
	lda (sp),y
	sta $4400 +  #$7f
	ldy #128
	lda (sp),y
	sta $4400 +  #$80
	ldy #129
	lda (sp),y
	sta $4400 +  #$81
	ldy #130
	lda (sp),y
	sta $4400 +  #$82
	ldy #131
	lda (sp),y
	sta $4400 +  #$83
	ldy #132
	lda (sp),y
	sta $4400 +  #$84
	ldy #133
	lda (sp),y
	sta $4400 +  #$85
	ldy #134
	lda (sp),y
	sta $4400 +  #$86
	ldy #135
	lda (sp),y
	sta $4400 +  #$87
	ldy #136
	lda (sp),y
	sta $4400 +  #$88
	ldy #137
	lda (sp),y
	sta $4400 +  #$89
	ldy #138
	lda (sp),y
	sta $4400 +  #$8a
	ldy #139
	lda (sp),y
	sta $4400 +  #$8b
	ldy #140
	lda (sp),y
	sta $4400 +  #$8c
	ldy #141
	lda (sp),y
	sta $4400 +  #$8d
	ldy #142
	lda (sp),y
	sta $4400 +  #$8e
	ldy #143
	lda (sp),y
	sta $4400 +  #$8f
	ldy #144
	lda (sp),y
	sta $4400 +  #$90
	ldy #145
	lda (sp),y
	sta $4400 +  #$91
	ldy #146
	lda (sp),y
	sta $4400 +  #$92
	ldy #147
	lda (sp),y
	sta $4400 +  #$93
	ldy #148
	lda (sp),y
	sta $4400 +  #$94
	ldy #149
	lda (sp),y
	sta $4400 +  #$95
	ldy #150
	lda (sp),y
	sta $4400 +  #$96
	ldy #151
	lda (sp),y
	sta $4400 +  #$97
	ldy #152
	lda (sp),y
	sta $4400 +  #$98
	ldy #153
	lda (sp),y
	sta $4400 +  #$99
	ldy #154
	lda (sp),y
	sta $4400 +  #$9a
	ldy #155
	lda (sp),y
	sta $4400 +  #$9b
	ldy #156
	lda (sp),y
	sta $4400 +  #$9c
	ldy #157
	lda (sp),y
	sta $4400 +  #$9d
	ldy #158
	lda (sp),y
	sta $4400 +  #$9e
	ldy #159
	lda (sp),y
	sta $4400 +  #$9f
	ldy #160
	lda (sp),y
	sta $4400 +  #$a0
	ldy #161
	lda (sp),y
	sta $4400 +  #$a1
	ldy #162
	lda (sp),y
	sta $4400 +  #$a2
	ldy #163
	lda (sp),y
	sta $4400 +  #$a3
	ldy #164
	lda (sp),y
	sta $4400 +  #$a4
	ldy #165
	lda (sp),y
	sta $4400 +  #$a5
	ldy #166
	lda (sp),y
	sta $4400 +  #$a6
	ldy #167
	lda (sp),y
	sta $4400 +  #$a7
	ldy #168
	lda (sp),y
	sta $4400 +  #$a8
	ldy #169
	lda (sp),y
	sta $4400 +  #$a9
	ldy #170
	lda (sp),y
	sta $4400 +  #$aa
	ldy #171
	lda (sp),y
	sta $4400 +  #$ab
	ldy #172
	lda (sp),y
	sta $4400 +  #$ac
	ldy #173
	lda (sp),y
	sta $4400 +  #$ad
	ldy #174
	lda (sp),y
	sta $4400 +  #$ae
	ldy #175
	lda (sp),y
	sta $4400 +  #$af
	ldy #176
	lda (sp),y
	sta $4400 +  #$b0
	ldy #177
	lda (sp),y
	sta $4400 +  #$b1
	ldy #178
	lda (sp),y
	sta $4400 +  #$b2
	ldy #179
	lda (sp),y
	sta $4400 +  #$b3
	ldy #180
	lda (sp),y
	sta $4400 +  #$b4
	ldy #181
	lda (sp),y
	sta $4400 +  #$b5
	ldy #182
	lda (sp),y
	sta $4400 +  #$b6
	ldy #183
	lda (sp),y
	sta $4400 +  #$b7
	ldy #184
	lda (sp),y
	sta $4400 +  #$b8
	ldy #185
	lda (sp),y
	sta $4400 +  #$b9
	ldy #186
	lda (sp),y
	sta $4400 +  #$ba
	ldy #187
	lda (sp),y
	sta $4400 +  #$bb
	ldy #188
	lda (sp),y
	sta $4400 +  #$bc
	ldy #189
	lda (sp),y
	sta $4400 +  #$bd
	ldy #190
	lda (sp),y
	sta $4400 +  #$be
	ldy #191
	lda (sp),y
	sta $4400 +  #$bf
	ldy #192
	lda (sp),y
	sta $4400 +  #$c0
	ldy #193
	lda (sp),y
	sta $4400 +  #$c1
	ldy #194
	lda (sp),y
	sta $4400 +  #$c2
	ldy #195
	lda (sp),y
	sta $4400 +  #$c3
	ldy #196
	lda (sp),y
	sta $4400 +  #$c4
	ldy #197
	lda (sp),y
	sta $4400 +  #$c5
	ldy #198
	lda (sp),y
	sta $4400 +  #$c6
	ldy #199
	lda (sp),y
	sta $4400 +  #$c7
	ldy #200
	lda (sp),y
	sta $4400 +  #$c8
	ldy #201
	lda (sp),y
	sta $4400 +  #$c9
	ldy #202
	lda (sp),y
	sta $4400 +  #$ca
	ldy #203
	lda (sp),y
	sta $4400 +  #$cb
	ldy #204
	lda (sp),y
	sta $4400 +  #$cc
	ldy #205
	lda (sp),y
	sta $4400 +  #$cd
	ldy #206
	lda (sp),y
	sta $4400 +  #$ce
	ldy #207
	lda (sp),y
	sta $4400 +  #$cf
	ldy #208
	lda (sp),y
	sta $4400 +  #$d0
	ldy #209
	lda (sp),y
	sta $4400 +  #$d1
	ldy #210
	lda (sp),y
	sta $4400 +  #$d2
	ldy #211
	lda (sp),y
	sta $4400 +  #$d3
	ldy #212
	lda (sp),y
	sta $4400 +  #$d4
	ldy #213
	lda (sp),y
	sta $4400 +  #$d5
	ldy #214
	lda (sp),y
	sta $4400 +  #$d6
	ldy #215
	lda (sp),y
	sta $4400 +  #$d7
	ldy #216
	lda (sp),y
	sta $4400 +  #$d8
	ldy #217
	lda (sp),y
	sta $4400 +  #$d9
	ldy #218
	lda (sp),y
	sta $4400 +  #$da
	ldy #219
	lda (sp),y
	sta $4400 +  #$db
	ldy #220
	lda (sp),y
	sta $4400 +  #$dc
	ldy #221
	lda (sp),y
	sta $4400 +  #$dd
	ldy #222
	lda (sp),y
	sta $4400 +  #$de
	ldy #223
	lda (sp),y
	sta $4400 +  #$df
	ldy #224
	lda (sp),y
	sta $4400 +  #$e0
	ldy #225
	lda (sp),y
	sta $4400 +  #$e1
	ldy #226
	lda (sp),y
	sta $4400 +  #$e2
	ldy #227
	lda (sp),y
	sta $4400 +  #$e3
	ldy #228
	lda (sp),y
	sta $4400 +  #$e4
	ldy #229
	lda (sp),y
	sta $4400 +  #$e5
	ldy #230
	lda (sp),y
	sta $4400 +  #$e6
	ldy #231
	lda (sp),y
	sta $4400 +  #$e7
	ldy #232
	lda (sp),y
	sta $4400 +  #$e8
	ldy #233
	lda (sp),y
	sta $4400 +  #$e9
	ldy #234
	lda (sp),y
	sta $4400 +  #$ea
	ldy #235
	lda (sp),y
	sta $4400 +  #$eb
	ldy #236
	lda (sp),y
	sta $4400 +  #$ec
	ldy #237
	lda (sp),y
	sta $4400 +  #$ed
	ldy #238
	lda (sp),y
	sta $4400 +  #$ee
	ldy #239
	lda (sp),y
	sta $4400 +  #$ef
	ldy #240
	lda (sp),y
	sta $4400 +  #$f0
	ldy #241
	lda (sp),y
	sta $4400 +  #$f1
	ldy #242
	lda (sp),y
	sta $4400 +  #$f2
	ldy #243
	lda (sp),y
	sta $4400 +  #$f3
	ldy #244
	lda (sp),y
	sta $4400 +  #$f4
	ldy #245
	lda (sp),y
	sta $4400 +  #$f5
	ldy #246
	lda (sp),y
	sta $4400 +  #$f6
	ldy #247
	lda (sp),y
	sta $4400 +  #$f7
	ldy #248
	lda (sp),y
	sta $4400 +  #$f8
	ldy #249
	lda (sp),y
	sta $4400 +  #$f9
	ldy #250
	lda (sp),y
	sta $4400 +  #$fa
	ldy #251
	lda (sp),y
	sta $4400 +  #$fb
	ldy #252
	lda (sp),y
	sta $4400 +  #$fc
	ldy #253
	lda (sp),y
	sta $4400 +  #$fd
	ldy #254
	lda (sp),y
	sta $4400 +  #$fe
	ldy #255
	lda (sp),y
	sta $4400 +  #$ff
	; 
	; ****** Inline assembler section
 inc sp+1 
	
	
; // Quick way of saying sp:=sp+256;
	; memcpy unrolled
	ldy #0
	lda (sp),y
	sta $4500 +  #$00
	ldy #1
	lda (sp),y
	sta $4500 +  #$01
	ldy #2
	lda (sp),y
	sta $4500 +  #$02
	ldy #3
	lda (sp),y
	sta $4500 +  #$03
	ldy #4
	lda (sp),y
	sta $4500 +  #$04
	ldy #5
	lda (sp),y
	sta $4500 +  #$05
	ldy #6
	lda (sp),y
	sta $4500 +  #$06
	ldy #7
	lda (sp),y
	sta $4500 +  #$07
	ldy #8
	lda (sp),y
	sta $4500 +  #$08
	ldy #9
	lda (sp),y
	sta $4500 +  #$09
	ldy #10
	lda (sp),y
	sta $4500 +  #$0a
	ldy #11
	lda (sp),y
	sta $4500 +  #$0b
	ldy #12
	lda (sp),y
	sta $4500 +  #$0c
	ldy #13
	lda (sp),y
	sta $4500 +  #$0d
	ldy #14
	lda (sp),y
	sta $4500 +  #$0e
	ldy #15
	lda (sp),y
	sta $4500 +  #$0f
	ldy #16
	lda (sp),y
	sta $4500 +  #$10
	ldy #17
	lda (sp),y
	sta $4500 +  #$11
	ldy #18
	lda (sp),y
	sta $4500 +  #$12
	ldy #19
	lda (sp),y
	sta $4500 +  #$13
	ldy #20
	lda (sp),y
	sta $4500 +  #$14
	ldy #21
	lda (sp),y
	sta $4500 +  #$15
	ldy #22
	lda (sp),y
	sta $4500 +  #$16
	ldy #23
	lda (sp),y
	sta $4500 +  #$17
	ldy #24
	lda (sp),y
	sta $4500 +  #$18
	ldy #25
	lda (sp),y
	sta $4500 +  #$19
	ldy #26
	lda (sp),y
	sta $4500 +  #$1a
	ldy #27
	lda (sp),y
	sta $4500 +  #$1b
	ldy #28
	lda (sp),y
	sta $4500 +  #$1c
	ldy #29
	lda (sp),y
	sta $4500 +  #$1d
	ldy #30
	lda (sp),y
	sta $4500 +  #$1e
	ldy #31
	lda (sp),y
	sta $4500 +  #$1f
	ldy #32
	lda (sp),y
	sta $4500 +  #$20
	ldy #33
	lda (sp),y
	sta $4500 +  #$21
	ldy #34
	lda (sp),y
	sta $4500 +  #$22
	ldy #35
	lda (sp),y
	sta $4500 +  #$23
	ldy #36
	lda (sp),y
	sta $4500 +  #$24
	ldy #37
	lda (sp),y
	sta $4500 +  #$25
	ldy #38
	lda (sp),y
	sta $4500 +  #$26
	ldy #39
	lda (sp),y
	sta $4500 +  #$27
	ldy #40
	lda (sp),y
	sta $4500 +  #$28
	ldy #41
	lda (sp),y
	sta $4500 +  #$29
	ldy #42
	lda (sp),y
	sta $4500 +  #$2a
	ldy #43
	lda (sp),y
	sta $4500 +  #$2b
	ldy #44
	lda (sp),y
	sta $4500 +  #$2c
	ldy #45
	lda (sp),y
	sta $4500 +  #$2d
	ldy #46
	lda (sp),y
	sta $4500 +  #$2e
	ldy #47
	lda (sp),y
	sta $4500 +  #$2f
	ldy #48
	lda (sp),y
	sta $4500 +  #$30
	ldy #49
	lda (sp),y
	sta $4500 +  #$31
	ldy #50
	lda (sp),y
	sta $4500 +  #$32
	ldy #51
	lda (sp),y
	sta $4500 +  #$33
	ldy #52
	lda (sp),y
	sta $4500 +  #$34
	ldy #53
	lda (sp),y
	sta $4500 +  #$35
	ldy #54
	lda (sp),y
	sta $4500 +  #$36
	ldy #55
	lda (sp),y
	sta $4500 +  #$37
	ldy #56
	lda (sp),y
	sta $4500 +  #$38
	ldy #57
	lda (sp),y
	sta $4500 +  #$39
	ldy #58
	lda (sp),y
	sta $4500 +  #$3a
	ldy #59
	lda (sp),y
	sta $4500 +  #$3b
	ldy #60
	lda (sp),y
	sta $4500 +  #$3c
	ldy #61
	lda (sp),y
	sta $4500 +  #$3d
	ldy #62
	lda (sp),y
	sta $4500 +  #$3e
	ldy #63
	lda (sp),y
	sta $4500 +  #$3f
	ldy #64
	lda (sp),y
	sta $4500 +  #$40
	ldy #65
	lda (sp),y
	sta $4500 +  #$41
	ldy #66
	lda (sp),y
	sta $4500 +  #$42
	ldy #67
	lda (sp),y
	sta $4500 +  #$43
	ldy #68
	lda (sp),y
	sta $4500 +  #$44
	ldy #69
	lda (sp),y
	sta $4500 +  #$45
	ldy #70
	lda (sp),y
	sta $4500 +  #$46
	ldy #71
	lda (sp),y
	sta $4500 +  #$47
	ldy #72
	lda (sp),y
	sta $4500 +  #$48
	ldy #73
	lda (sp),y
	sta $4500 +  #$49
	ldy #74
	lda (sp),y
	sta $4500 +  #$4a
	ldy #75
	lda (sp),y
	sta $4500 +  #$4b
	ldy #76
	lda (sp),y
	sta $4500 +  #$4c
	ldy #77
	lda (sp),y
	sta $4500 +  #$4d
	ldy #78
	lda (sp),y
	sta $4500 +  #$4e
	ldy #79
	lda (sp),y
	sta $4500 +  #$4f
	ldy #80
	lda (sp),y
	sta $4500 +  #$50
	ldy #81
	lda (sp),y
	sta $4500 +  #$51
	ldy #82
	lda (sp),y
	sta $4500 +  #$52
	ldy #83
	lda (sp),y
	sta $4500 +  #$53
	ldy #84
	lda (sp),y
	sta $4500 +  #$54
	ldy #85
	lda (sp),y
	sta $4500 +  #$55
	ldy #86
	lda (sp),y
	sta $4500 +  #$56
	ldy #87
	lda (sp),y
	sta $4500 +  #$57
	ldy #88
	lda (sp),y
	sta $4500 +  #$58
	ldy #89
	lda (sp),y
	sta $4500 +  #$59
	ldy #90
	lda (sp),y
	sta $4500 +  #$5a
	ldy #91
	lda (sp),y
	sta $4500 +  #$5b
	ldy #92
	lda (sp),y
	sta $4500 +  #$5c
	ldy #93
	lda (sp),y
	sta $4500 +  #$5d
	ldy #94
	lda (sp),y
	sta $4500 +  #$5e
	ldy #95
	lda (sp),y
	sta $4500 +  #$5f
	ldy #96
	lda (sp),y
	sta $4500 +  #$60
	ldy #97
	lda (sp),y
	sta $4500 +  #$61
	ldy #98
	lda (sp),y
	sta $4500 +  #$62
	ldy #99
	lda (sp),y
	sta $4500 +  #$63
	ldy #100
	lda (sp),y
	sta $4500 +  #$64
	ldy #101
	lda (sp),y
	sta $4500 +  #$65
	ldy #102
	lda (sp),y
	sta $4500 +  #$66
	ldy #103
	lda (sp),y
	sta $4500 +  #$67
	ldy #104
	lda (sp),y
	sta $4500 +  #$68
	ldy #105
	lda (sp),y
	sta $4500 +  #$69
	ldy #106
	lda (sp),y
	sta $4500 +  #$6a
	ldy #107
	lda (sp),y
	sta $4500 +  #$6b
	ldy #108
	lda (sp),y
	sta $4500 +  #$6c
	ldy #109
	lda (sp),y
	sta $4500 +  #$6d
	ldy #110
	lda (sp),y
	sta $4500 +  #$6e
	ldy #111
	lda (sp),y
	sta $4500 +  #$6f
	ldy #112
	lda (sp),y
	sta $4500 +  #$70
	ldy #113
	lda (sp),y
	sta $4500 +  #$71
	ldy #114
	lda (sp),y
	sta $4500 +  #$72
	ldy #115
	lda (sp),y
	sta $4500 +  #$73
	ldy #116
	lda (sp),y
	sta $4500 +  #$74
	ldy #117
	lda (sp),y
	sta $4500 +  #$75
	ldy #118
	lda (sp),y
	sta $4500 +  #$76
	ldy #119
	lda (sp),y
	sta $4500 +  #$77
	ldy #120
	lda (sp),y
	sta $4500 +  #$78
	ldy #121
	lda (sp),y
	sta $4500 +  #$79
	ldy #122
	lda (sp),y
	sta $4500 +  #$7a
	ldy #123
	lda (sp),y
	sta $4500 +  #$7b
	ldy #124
	lda (sp),y
	sta $4500 +  #$7c
	ldy #125
	lda (sp),y
	sta $4500 +  #$7d
	ldy #126
	lda (sp),y
	sta $4500 +  #$7e
	ldy #127
	lda (sp),y
	sta $4500 +  #$7f
	ldy #128
	lda (sp),y
	sta $4500 +  #$80
	ldy #129
	lda (sp),y
	sta $4500 +  #$81
	ldy #130
	lda (sp),y
	sta $4500 +  #$82
	ldy #131
	lda (sp),y
	sta $4500 +  #$83
	ldy #132
	lda (sp),y
	sta $4500 +  #$84
	ldy #133
	lda (sp),y
	sta $4500 +  #$85
	ldy #134
	lda (sp),y
	sta $4500 +  #$86
	ldy #135
	lda (sp),y
	sta $4500 +  #$87
	ldy #136
	lda (sp),y
	sta $4500 +  #$88
	ldy #137
	lda (sp),y
	sta $4500 +  #$89
	ldy #138
	lda (sp),y
	sta $4500 +  #$8a
	ldy #139
	lda (sp),y
	sta $4500 +  #$8b
	ldy #140
	lda (sp),y
	sta $4500 +  #$8c
	ldy #141
	lda (sp),y
	sta $4500 +  #$8d
	ldy #142
	lda (sp),y
	sta $4500 +  #$8e
	ldy #143
	lda (sp),y
	sta $4500 +  #$8f
	ldy #144
	lda (sp),y
	sta $4500 +  #$90
	ldy #145
	lda (sp),y
	sta $4500 +  #$91
	ldy #146
	lda (sp),y
	sta $4500 +  #$92
	ldy #147
	lda (sp),y
	sta $4500 +  #$93
	ldy #148
	lda (sp),y
	sta $4500 +  #$94
	ldy #149
	lda (sp),y
	sta $4500 +  #$95
	ldy #150
	lda (sp),y
	sta $4500 +  #$96
	ldy #151
	lda (sp),y
	sta $4500 +  #$97
	ldy #152
	lda (sp),y
	sta $4500 +  #$98
	ldy #153
	lda (sp),y
	sta $4500 +  #$99
	ldy #154
	lda (sp),y
	sta $4500 +  #$9a
	ldy #155
	lda (sp),y
	sta $4500 +  #$9b
	ldy #156
	lda (sp),y
	sta $4500 +  #$9c
	ldy #157
	lda (sp),y
	sta $4500 +  #$9d
	ldy #158
	lda (sp),y
	sta $4500 +  #$9e
	ldy #159
	lda (sp),y
	sta $4500 +  #$9f
	ldy #160
	lda (sp),y
	sta $4500 +  #$a0
	ldy #161
	lda (sp),y
	sta $4500 +  #$a1
	ldy #162
	lda (sp),y
	sta $4500 +  #$a2
	ldy #163
	lda (sp),y
	sta $4500 +  #$a3
	ldy #164
	lda (sp),y
	sta $4500 +  #$a4
	ldy #165
	lda (sp),y
	sta $4500 +  #$a5
	ldy #166
	lda (sp),y
	sta $4500 +  #$a6
	ldy #167
	lda (sp),y
	sta $4500 +  #$a7
	ldy #168
	lda (sp),y
	sta $4500 +  #$a8
	ldy #169
	lda (sp),y
	sta $4500 +  #$a9
	ldy #170
	lda (sp),y
	sta $4500 +  #$aa
	ldy #171
	lda (sp),y
	sta $4500 +  #$ab
	ldy #172
	lda (sp),y
	sta $4500 +  #$ac
	ldy #173
	lda (sp),y
	sta $4500 +  #$ad
	ldy #174
	lda (sp),y
	sta $4500 +  #$ae
	ldy #175
	lda (sp),y
	sta $4500 +  #$af
	ldy #176
	lda (sp),y
	sta $4500 +  #$b0
	ldy #177
	lda (sp),y
	sta $4500 +  #$b1
	ldy #178
	lda (sp),y
	sta $4500 +  #$b2
	ldy #179
	lda (sp),y
	sta $4500 +  #$b3
	ldy #180
	lda (sp),y
	sta $4500 +  #$b4
	ldy #181
	lda (sp),y
	sta $4500 +  #$b5
	ldy #182
	lda (sp),y
	sta $4500 +  #$b6
	ldy #183
	lda (sp),y
	sta $4500 +  #$b7
	ldy #184
	lda (sp),y
	sta $4500 +  #$b8
	ldy #185
	lda (sp),y
	sta $4500 +  #$b9
	ldy #186
	lda (sp),y
	sta $4500 +  #$ba
	ldy #187
	lda (sp),y
	sta $4500 +  #$bb
	ldy #188
	lda (sp),y
	sta $4500 +  #$bc
	ldy #189
	lda (sp),y
	sta $4500 +  #$bd
	ldy #190
	lda (sp),y
	sta $4500 +  #$be
	ldy #191
	lda (sp),y
	sta $4500 +  #$bf
	ldy #192
	lda (sp),y
	sta $4500 +  #$c0
	ldy #193
	lda (sp),y
	sta $4500 +  #$c1
	ldy #194
	lda (sp),y
	sta $4500 +  #$c2
	ldy #195
	lda (sp),y
	sta $4500 +  #$c3
	ldy #196
	lda (sp),y
	sta $4500 +  #$c4
	ldy #197
	lda (sp),y
	sta $4500 +  #$c5
	ldy #198
	lda (sp),y
	sta $4500 +  #$c6
	ldy #199
	lda (sp),y
	sta $4500 +  #$c7
	ldy #200
	lda (sp),y
	sta $4500 +  #$c8
	ldy #201
	lda (sp),y
	sta $4500 +  #$c9
	ldy #202
	lda (sp),y
	sta $4500 +  #$ca
	ldy #203
	lda (sp),y
	sta $4500 +  #$cb
	ldy #204
	lda (sp),y
	sta $4500 +  #$cc
	ldy #205
	lda (sp),y
	sta $4500 +  #$cd
	ldy #206
	lda (sp),y
	sta $4500 +  #$ce
	ldy #207
	lda (sp),y
	sta $4500 +  #$cf
	ldy #208
	lda (sp),y
	sta $4500 +  #$d0
	ldy #209
	lda (sp),y
	sta $4500 +  #$d1
	ldy #210
	lda (sp),y
	sta $4500 +  #$d2
	ldy #211
	lda (sp),y
	sta $4500 +  #$d3
	ldy #212
	lda (sp),y
	sta $4500 +  #$d4
	ldy #213
	lda (sp),y
	sta $4500 +  #$d5
	ldy #214
	lda (sp),y
	sta $4500 +  #$d6
	ldy #215
	lda (sp),y
	sta $4500 +  #$d7
	ldy #216
	lda (sp),y
	sta $4500 +  #$d8
	ldy #217
	lda (sp),y
	sta $4500 +  #$d9
	ldy #218
	lda (sp),y
	sta $4500 +  #$da
	ldy #219
	lda (sp),y
	sta $4500 +  #$db
	ldy #220
	lda (sp),y
	sta $4500 +  #$dc
	ldy #221
	lda (sp),y
	sta $4500 +  #$dd
	ldy #222
	lda (sp),y
	sta $4500 +  #$de
	ldy #223
	lda (sp),y
	sta $4500 +  #$df
	ldy #224
	lda (sp),y
	sta $4500 +  #$e0
	ldy #225
	lda (sp),y
	sta $4500 +  #$e1
	ldy #226
	lda (sp),y
	sta $4500 +  #$e2
	ldy #227
	lda (sp),y
	sta $4500 +  #$e3
	ldy #228
	lda (sp),y
	sta $4500 +  #$e4
	ldy #229
	lda (sp),y
	sta $4500 +  #$e5
	ldy #230
	lda (sp),y
	sta $4500 +  #$e6
	ldy #231
	lda (sp),y
	sta $4500 +  #$e7
	ldy #232
	lda (sp),y
	sta $4500 +  #$e8
	ldy #233
	lda (sp),y
	sta $4500 +  #$e9
	ldy #234
	lda (sp),y
	sta $4500 +  #$ea
	ldy #235
	lda (sp),y
	sta $4500 +  #$eb
	ldy #236
	lda (sp),y
	sta $4500 +  #$ec
	ldy #237
	lda (sp),y
	sta $4500 +  #$ed
	ldy #238
	lda (sp),y
	sta $4500 +  #$ee
	ldy #239
	lda (sp),y
	sta $4500 +  #$ef
	ldy #240
	lda (sp),y
	sta $4500 +  #$f0
	ldy #241
	lda (sp),y
	sta $4500 +  #$f1
	ldy #242
	lda (sp),y
	sta $4500 +  #$f2
	ldy #243
	lda (sp),y
	sta $4500 +  #$f3
	ldy #244
	lda (sp),y
	sta $4500 +  #$f4
	ldy #245
	lda (sp),y
	sta $4500 +  #$f5
	ldy #246
	lda (sp),y
	sta $4500 +  #$f6
	ldy #247
	lda (sp),y
	sta $4500 +  #$f7
	ldy #248
	lda (sp),y
	sta $4500 +  #$f8
	ldy #249
	lda (sp),y
	sta $4500 +  #$f9
	ldy #250
	lda (sp),y
	sta $4500 +  #$fa
	ldy #251
	lda (sp),y
	sta $4500 +  #$fb
	ldy #252
	lda (sp),y
	sta $4500 +  #$fc
	ldy #253
	lda (sp),y
	sta $4500 +  #$fd
	ldy #254
	lda (sp),y
	sta $4500 +  #$fe
	ldy #255
	lda (sp),y
	sta $4500 +  #$ff
	; 
	; ****** Inline assembler section
 inc sp+1 
	
	; memcpy unrolled
	ldy #0
	lda (sp),y
	sta $4600 +  #$00
	ldy #1
	lda (sp),y
	sta $4600 +  #$01
	ldy #2
	lda (sp),y
	sta $4600 +  #$02
	ldy #3
	lda (sp),y
	sta $4600 +  #$03
	ldy #4
	lda (sp),y
	sta $4600 +  #$04
	ldy #5
	lda (sp),y
	sta $4600 +  #$05
	ldy #6
	lda (sp),y
	sta $4600 +  #$06
	ldy #7
	lda (sp),y
	sta $4600 +  #$07
	ldy #8
	lda (sp),y
	sta $4600 +  #$08
	ldy #9
	lda (sp),y
	sta $4600 +  #$09
	ldy #10
	lda (sp),y
	sta $4600 +  #$0a
	ldy #11
	lda (sp),y
	sta $4600 +  #$0b
	ldy #12
	lda (sp),y
	sta $4600 +  #$0c
	ldy #13
	lda (sp),y
	sta $4600 +  #$0d
	ldy #14
	lda (sp),y
	sta $4600 +  #$0e
	ldy #15
	lda (sp),y
	sta $4600 +  #$0f
	ldy #16
	lda (sp),y
	sta $4600 +  #$10
	ldy #17
	lda (sp),y
	sta $4600 +  #$11
	ldy #18
	lda (sp),y
	sta $4600 +  #$12
	ldy #19
	lda (sp),y
	sta $4600 +  #$13
	ldy #20
	lda (sp),y
	sta $4600 +  #$14
	ldy #21
	lda (sp),y
	sta $4600 +  #$15
	ldy #22
	lda (sp),y
	sta $4600 +  #$16
	ldy #23
	lda (sp),y
	sta $4600 +  #$17
	ldy #24
	lda (sp),y
	sta $4600 +  #$18
	ldy #25
	lda (sp),y
	sta $4600 +  #$19
	ldy #26
	lda (sp),y
	sta $4600 +  #$1a
	ldy #27
	lda (sp),y
	sta $4600 +  #$1b
	ldy #28
	lda (sp),y
	sta $4600 +  #$1c
	ldy #29
	lda (sp),y
	sta $4600 +  #$1d
	ldy #30
	lda (sp),y
	sta $4600 +  #$1e
	ldy #31
	lda (sp),y
	sta $4600 +  #$1f
	ldy #32
	lda (sp),y
	sta $4600 +  #$20
	ldy #33
	lda (sp),y
	sta $4600 +  #$21
	ldy #34
	lda (sp),y
	sta $4600 +  #$22
	ldy #35
	lda (sp),y
	sta $4600 +  #$23
	ldy #36
	lda (sp),y
	sta $4600 +  #$24
	ldy #37
	lda (sp),y
	sta $4600 +  #$25
	ldy #38
	lda (sp),y
	sta $4600 +  #$26
	ldy #39
	lda (sp),y
	sta $4600 +  #$27
	ldy #40
	lda (sp),y
	sta $4600 +  #$28
	ldy #41
	lda (sp),y
	sta $4600 +  #$29
	ldy #42
	lda (sp),y
	sta $4600 +  #$2a
	ldy #43
	lda (sp),y
	sta $4600 +  #$2b
	ldy #44
	lda (sp),y
	sta $4600 +  #$2c
	ldy #45
	lda (sp),y
	sta $4600 +  #$2d
	ldy #46
	lda (sp),y
	sta $4600 +  #$2e
	ldy #47
	lda (sp),y
	sta $4600 +  #$2f
	ldy #48
	lda (sp),y
	sta $4600 +  #$30
	ldy #49
	lda (sp),y
	sta $4600 +  #$31
	ldy #50
	lda (sp),y
	sta $4600 +  #$32
	ldy #51
	lda (sp),y
	sta $4600 +  #$33
	ldy #52
	lda (sp),y
	sta $4600 +  #$34
	ldy #53
	lda (sp),y
	sta $4600 +  #$35
	ldy #54
	lda (sp),y
	sta $4600 +  #$36
	ldy #55
	lda (sp),y
	sta $4600 +  #$37
	ldy #56
	lda (sp),y
	sta $4600 +  #$38
	ldy #57
	lda (sp),y
	sta $4600 +  #$39
	ldy #58
	lda (sp),y
	sta $4600 +  #$3a
	ldy #59
	lda (sp),y
	sta $4600 +  #$3b
	ldy #60
	lda (sp),y
	sta $4600 +  #$3c
	ldy #61
	lda (sp),y
	sta $4600 +  #$3d
	ldy #62
	lda (sp),y
	sta $4600 +  #$3e
	ldy #63
	lda (sp),y
	sta $4600 +  #$3f
	ldy #64
	lda (sp),y
	sta $4600 +  #$40
	ldy #65
	lda (sp),y
	sta $4600 +  #$41
	ldy #66
	lda (sp),y
	sta $4600 +  #$42
	ldy #67
	lda (sp),y
	sta $4600 +  #$43
	ldy #68
	lda (sp),y
	sta $4600 +  #$44
	ldy #69
	lda (sp),y
	sta $4600 +  #$45
	ldy #70
	lda (sp),y
	sta $4600 +  #$46
	ldy #71
	lda (sp),y
	sta $4600 +  #$47
	ldy #72
	lda (sp),y
	sta $4600 +  #$48
	ldy #73
	lda (sp),y
	sta $4600 +  #$49
	ldy #74
	lda (sp),y
	sta $4600 +  #$4a
	ldy #75
	lda (sp),y
	sta $4600 +  #$4b
	ldy #76
	lda (sp),y
	sta $4600 +  #$4c
	ldy #77
	lda (sp),y
	sta $4600 +  #$4d
	ldy #78
	lda (sp),y
	sta $4600 +  #$4e
	ldy #79
	lda (sp),y
	sta $4600 +  #$4f
	ldy #80
	lda (sp),y
	sta $4600 +  #$50
	ldy #81
	lda (sp),y
	sta $4600 +  #$51
	ldy #82
	lda (sp),y
	sta $4600 +  #$52
	ldy #83
	lda (sp),y
	sta $4600 +  #$53
	ldy #84
	lda (sp),y
	sta $4600 +  #$54
	ldy #85
	lda (sp),y
	sta $4600 +  #$55
	ldy #86
	lda (sp),y
	sta $4600 +  #$56
	ldy #87
	lda (sp),y
	sta $4600 +  #$57
	ldy #88
	lda (sp),y
	sta $4600 +  #$58
	ldy #89
	lda (sp),y
	sta $4600 +  #$59
	ldy #90
	lda (sp),y
	sta $4600 +  #$5a
	ldy #91
	lda (sp),y
	sta $4600 +  #$5b
	ldy #92
	lda (sp),y
	sta $4600 +  #$5c
	ldy #93
	lda (sp),y
	sta $4600 +  #$5d
	ldy #94
	lda (sp),y
	sta $4600 +  #$5e
	ldy #95
	lda (sp),y
	sta $4600 +  #$5f
	ldy #96
	lda (sp),y
	sta $4600 +  #$60
	ldy #97
	lda (sp),y
	sta $4600 +  #$61
	ldy #98
	lda (sp),y
	sta $4600 +  #$62
	ldy #99
	lda (sp),y
	sta $4600 +  #$63
	ldy #100
	lda (sp),y
	sta $4600 +  #$64
	ldy #101
	lda (sp),y
	sta $4600 +  #$65
	ldy #102
	lda (sp),y
	sta $4600 +  #$66
	ldy #103
	lda (sp),y
	sta $4600 +  #$67
	ldy #104
	lda (sp),y
	sta $4600 +  #$68
	ldy #105
	lda (sp),y
	sta $4600 +  #$69
	ldy #106
	lda (sp),y
	sta $4600 +  #$6a
	ldy #107
	lda (sp),y
	sta $4600 +  #$6b
	ldy #108
	lda (sp),y
	sta $4600 +  #$6c
	ldy #109
	lda (sp),y
	sta $4600 +  #$6d
	ldy #110
	lda (sp),y
	sta $4600 +  #$6e
	ldy #111
	lda (sp),y
	sta $4600 +  #$6f
	ldy #112
	lda (sp),y
	sta $4600 +  #$70
	ldy #113
	lda (sp),y
	sta $4600 +  #$71
	ldy #114
	lda (sp),y
	sta $4600 +  #$72
	ldy #115
	lda (sp),y
	sta $4600 +  #$73
	ldy #116
	lda (sp),y
	sta $4600 +  #$74
	ldy #117
	lda (sp),y
	sta $4600 +  #$75
	ldy #118
	lda (sp),y
	sta $4600 +  #$76
	ldy #119
	lda (sp),y
	sta $4600 +  #$77
	ldy #120
	lda (sp),y
	sta $4600 +  #$78
	ldy #121
	lda (sp),y
	sta $4600 +  #$79
	ldy #122
	lda (sp),y
	sta $4600 +  #$7a
	ldy #123
	lda (sp),y
	sta $4600 +  #$7b
	ldy #124
	lda (sp),y
	sta $4600 +  #$7c
	ldy #125
	lda (sp),y
	sta $4600 +  #$7d
	ldy #126
	lda (sp),y
	sta $4600 +  #$7e
	ldy #127
	lda (sp),y
	sta $4600 +  #$7f
	ldy #128
	lda (sp),y
	sta $4600 +  #$80
	ldy #129
	lda (sp),y
	sta $4600 +  #$81
	ldy #130
	lda (sp),y
	sta $4600 +  #$82
	ldy #131
	lda (sp),y
	sta $4600 +  #$83
	ldy #132
	lda (sp),y
	sta $4600 +  #$84
	ldy #133
	lda (sp),y
	sta $4600 +  #$85
	ldy #134
	lda (sp),y
	sta $4600 +  #$86
	ldy #135
	lda (sp),y
	sta $4600 +  #$87
	ldy #136
	lda (sp),y
	sta $4600 +  #$88
	ldy #137
	lda (sp),y
	sta $4600 +  #$89
	ldy #138
	lda (sp),y
	sta $4600 +  #$8a
	ldy #139
	lda (sp),y
	sta $4600 +  #$8b
	ldy #140
	lda (sp),y
	sta $4600 +  #$8c
	ldy #141
	lda (sp),y
	sta $4600 +  #$8d
	ldy #142
	lda (sp),y
	sta $4600 +  #$8e
	ldy #143
	lda (sp),y
	sta $4600 +  #$8f
	ldy #144
	lda (sp),y
	sta $4600 +  #$90
	ldy #145
	lda (sp),y
	sta $4600 +  #$91
	ldy #146
	lda (sp),y
	sta $4600 +  #$92
	ldy #147
	lda (sp),y
	sta $4600 +  #$93
	ldy #148
	lda (sp),y
	sta $4600 +  #$94
	ldy #149
	lda (sp),y
	sta $4600 +  #$95
	ldy #150
	lda (sp),y
	sta $4600 +  #$96
	ldy #151
	lda (sp),y
	sta $4600 +  #$97
	ldy #152
	lda (sp),y
	sta $4600 +  #$98
	ldy #153
	lda (sp),y
	sta $4600 +  #$99
	ldy #154
	lda (sp),y
	sta $4600 +  #$9a
	ldy #155
	lda (sp),y
	sta $4600 +  #$9b
	ldy #156
	lda (sp),y
	sta $4600 +  #$9c
	ldy #157
	lda (sp),y
	sta $4600 +  #$9d
	ldy #158
	lda (sp),y
	sta $4600 +  #$9e
	ldy #159
	lda (sp),y
	sta $4600 +  #$9f
	ldy #160
	lda (sp),y
	sta $4600 +  #$a0
	ldy #161
	lda (sp),y
	sta $4600 +  #$a1
	ldy #162
	lda (sp),y
	sta $4600 +  #$a2
	ldy #163
	lda (sp),y
	sta $4600 +  #$a3
	ldy #164
	lda (sp),y
	sta $4600 +  #$a4
	ldy #165
	lda (sp),y
	sta $4600 +  #$a5
	ldy #166
	lda (sp),y
	sta $4600 +  #$a6
	ldy #167
	lda (sp),y
	sta $4600 +  #$a7
	ldy #168
	lda (sp),y
	sta $4600 +  #$a8
	ldy #169
	lda (sp),y
	sta $4600 +  #$a9
	ldy #170
	lda (sp),y
	sta $4600 +  #$aa
	ldy #171
	lda (sp),y
	sta $4600 +  #$ab
	ldy #172
	lda (sp),y
	sta $4600 +  #$ac
	ldy #173
	lda (sp),y
	sta $4600 +  #$ad
	ldy #174
	lda (sp),y
	sta $4600 +  #$ae
	ldy #175
	lda (sp),y
	sta $4600 +  #$af
	ldy #176
	lda (sp),y
	sta $4600 +  #$b0
	ldy #177
	lda (sp),y
	sta $4600 +  #$b1
	ldy #178
	lda (sp),y
	sta $4600 +  #$b2
	ldy #179
	lda (sp),y
	sta $4600 +  #$b3
	ldy #180
	lda (sp),y
	sta $4600 +  #$b4
	ldy #181
	lda (sp),y
	sta $4600 +  #$b5
	ldy #182
	lda (sp),y
	sta $4600 +  #$b6
	ldy #183
	lda (sp),y
	sta $4600 +  #$b7
	ldy #184
	lda (sp),y
	sta $4600 +  #$b8
	ldy #185
	lda (sp),y
	sta $4600 +  #$b9
	ldy #186
	lda (sp),y
	sta $4600 +  #$ba
	ldy #187
	lda (sp),y
	sta $4600 +  #$bb
	ldy #188
	lda (sp),y
	sta $4600 +  #$bc
	ldy #189
	lda (sp),y
	sta $4600 +  #$bd
	ldy #190
	lda (sp),y
	sta $4600 +  #$be
	ldy #191
	lda (sp),y
	sta $4600 +  #$bf
	ldy #192
	lda (sp),y
	sta $4600 +  #$c0
	ldy #193
	lda (sp),y
	sta $4600 +  #$c1
	ldy #194
	lda (sp),y
	sta $4600 +  #$c2
	ldy #195
	lda (sp),y
	sta $4600 +  #$c3
	ldy #196
	lda (sp),y
	sta $4600 +  #$c4
	ldy #197
	lda (sp),y
	sta $4600 +  #$c5
	ldy #198
	lda (sp),y
	sta $4600 +  #$c6
	ldy #199
	lda (sp),y
	sta $4600 +  #$c7
	ldy #200
	lda (sp),y
	sta $4600 +  #$c8
	ldy #201
	lda (sp),y
	sta $4600 +  #$c9
	ldy #202
	lda (sp),y
	sta $4600 +  #$ca
	ldy #203
	lda (sp),y
	sta $4600 +  #$cb
	ldy #204
	lda (sp),y
	sta $4600 +  #$cc
	ldy #205
	lda (sp),y
	sta $4600 +  #$cd
	ldy #206
	lda (sp),y
	sta $4600 +  #$ce
	ldy #207
	lda (sp),y
	sta $4600 +  #$cf
	ldy #208
	lda (sp),y
	sta $4600 +  #$d0
	ldy #209
	lda (sp),y
	sta $4600 +  #$d1
	ldy #210
	lda (sp),y
	sta $4600 +  #$d2
	ldy #211
	lda (sp),y
	sta $4600 +  #$d3
	ldy #212
	lda (sp),y
	sta $4600 +  #$d4
	ldy #213
	lda (sp),y
	sta $4600 +  #$d5
	ldy #214
	lda (sp),y
	sta $4600 +  #$d6
	ldy #215
	lda (sp),y
	sta $4600 +  #$d7
	ldy #216
	lda (sp),y
	sta $4600 +  #$d8
	ldy #217
	lda (sp),y
	sta $4600 +  #$d9
	ldy #218
	lda (sp),y
	sta $4600 +  #$da
	ldy #219
	lda (sp),y
	sta $4600 +  #$db
	ldy #220
	lda (sp),y
	sta $4600 +  #$dc
	ldy #221
	lda (sp),y
	sta $4600 +  #$dd
	ldy #222
	lda (sp),y
	sta $4600 +  #$de
	ldy #223
	lda (sp),y
	sta $4600 +  #$df
	ldy #224
	lda (sp),y
	sta $4600 +  #$e0
	ldy #225
	lda (sp),y
	sta $4600 +  #$e1
	ldy #226
	lda (sp),y
	sta $4600 +  #$e2
	ldy #227
	lda (sp),y
	sta $4600 +  #$e3
	ldy #228
	lda (sp),y
	sta $4600 +  #$e4
	ldy #229
	lda (sp),y
	sta $4600 +  #$e5
	ldy #230
	lda (sp),y
	sta $4600 +  #$e6
	ldy #231
	lda (sp),y
	sta $4600 +  #$e7
	ldy #232
	lda (sp),y
	sta $4600 +  #$e8
	ldy #233
	lda (sp),y
	sta $4600 +  #$e9
	ldy #234
	lda (sp),y
	sta $4600 +  #$ea
	ldy #235
	lda (sp),y
	sta $4600 +  #$eb
	ldy #236
	lda (sp),y
	sta $4600 +  #$ec
	ldy #237
	lda (sp),y
	sta $4600 +  #$ed
	ldy #238
	lda (sp),y
	sta $4600 +  #$ee
	ldy #239
	lda (sp),y
	sta $4600 +  #$ef
	ldy #240
	lda (sp),y
	sta $4600 +  #$f0
	ldy #241
	lda (sp),y
	sta $4600 +  #$f1
	ldy #242
	lda (sp),y
	sta $4600 +  #$f2
	ldy #243
	lda (sp),y
	sta $4600 +  #$f3
	ldy #244
	lda (sp),y
	sta $4600 +  #$f4
	ldy #245
	lda (sp),y
	sta $4600 +  #$f5
	ldy #246
	lda (sp),y
	sta $4600 +  #$f6
	ldy #247
	lda (sp),y
	sta $4600 +  #$f7
	ldy #248
	lda (sp),y
	sta $4600 +  #$f8
	ldy #249
	lda (sp),y
	sta $4600 +  #$f9
	ldy #250
	lda (sp),y
	sta $4600 +  #$fa
	ldy #251
	lda (sp),y
	sta $4600 +  #$fb
	ldy #252
	lda (sp),y
	sta $4600 +  #$fc
	ldy #253
	lda (sp),y
	sta $4600 +  #$fd
	ldy #254
	lda (sp),y
	sta $4600 +  #$fe
	ldy #255
	lda (sp),y
	sta $4600 +  #$ff
	; 
	; ****** Inline assembler section
 inc sp+1 
	
	; memcpy unrolled
	ldy #0
	lda (sp),y
	sta $4700 +  #$00
	ldy #1
	lda (sp),y
	sta $4700 +  #$01
	ldy #2
	lda (sp),y
	sta $4700 +  #$02
	ldy #3
	lda (sp),y
	sta $4700 +  #$03
	ldy #4
	lda (sp),y
	sta $4700 +  #$04
	ldy #5
	lda (sp),y
	sta $4700 +  #$05
	ldy #6
	lda (sp),y
	sta $4700 +  #$06
	ldy #7
	lda (sp),y
	sta $4700 +  #$07
	ldy #8
	lda (sp),y
	sta $4700 +  #$08
	ldy #9
	lda (sp),y
	sta $4700 +  #$09
	ldy #10
	lda (sp),y
	sta $4700 +  #$0a
	ldy #11
	lda (sp),y
	sta $4700 +  #$0b
	ldy #12
	lda (sp),y
	sta $4700 +  #$0c
	ldy #13
	lda (sp),y
	sta $4700 +  #$0d
	ldy #14
	lda (sp),y
	sta $4700 +  #$0e
	ldy #15
	lda (sp),y
	sta $4700 +  #$0f
	ldy #16
	lda (sp),y
	sta $4700 +  #$10
	ldy #17
	lda (sp),y
	sta $4700 +  #$11
	ldy #18
	lda (sp),y
	sta $4700 +  #$12
	ldy #19
	lda (sp),y
	sta $4700 +  #$13
	ldy #20
	lda (sp),y
	sta $4700 +  #$14
	ldy #21
	lda (sp),y
	sta $4700 +  #$15
	ldy #22
	lda (sp),y
	sta $4700 +  #$16
	ldy #23
	lda (sp),y
	sta $4700 +  #$17
	ldy #24
	lda (sp),y
	sta $4700 +  #$18
	ldy #25
	lda (sp),y
	sta $4700 +  #$19
	ldy #26
	lda (sp),y
	sta $4700 +  #$1a
	ldy #27
	lda (sp),y
	sta $4700 +  #$1b
	ldy #28
	lda (sp),y
	sta $4700 +  #$1c
	ldy #29
	lda (sp),y
	sta $4700 +  #$1d
	ldy #30
	lda (sp),y
	sta $4700 +  #$1e
	ldy #31
	lda (sp),y
	sta $4700 +  #$1f
	ldy #32
	lda (sp),y
	sta $4700 +  #$20
	ldy #33
	lda (sp),y
	sta $4700 +  #$21
	ldy #34
	lda (sp),y
	sta $4700 +  #$22
	ldy #35
	lda (sp),y
	sta $4700 +  #$23
	ldy #36
	lda (sp),y
	sta $4700 +  #$24
	ldy #37
	lda (sp),y
	sta $4700 +  #$25
	ldy #38
	lda (sp),y
	sta $4700 +  #$26
	ldy #39
	lda (sp),y
	sta $4700 +  #$27
	ldy #40
	lda (sp),y
	sta $4700 +  #$28
	ldy #41
	lda (sp),y
	sta $4700 +  #$29
	ldy #42
	lda (sp),y
	sta $4700 +  #$2a
	ldy #43
	lda (sp),y
	sta $4700 +  #$2b
	ldy #44
	lda (sp),y
	sta $4700 +  #$2c
	ldy #45
	lda (sp),y
	sta $4700 +  #$2d
	ldy #46
	lda (sp),y
	sta $4700 +  #$2e
	ldy #47
	lda (sp),y
	sta $4700 +  #$2f
	ldy #48
	lda (sp),y
	sta $4700 +  #$30
	ldy #49
	lda (sp),y
	sta $4700 +  #$31
	ldy #50
	lda (sp),y
	sta $4700 +  #$32
	ldy #51
	lda (sp),y
	sta $4700 +  #$33
	ldy #52
	lda (sp),y
	sta $4700 +  #$34
	ldy #53
	lda (sp),y
	sta $4700 +  #$35
	ldy #54
	lda (sp),y
	sta $4700 +  #$36
	ldy #55
	lda (sp),y
	sta $4700 +  #$37
	ldy #56
	lda (sp),y
	sta $4700 +  #$38
	ldy #57
	lda (sp),y
	sta $4700 +  #$39
	ldy #58
	lda (sp),y
	sta $4700 +  #$3a
	ldy #59
	lda (sp),y
	sta $4700 +  #$3b
	ldy #60
	lda (sp),y
	sta $4700 +  #$3c
	ldy #61
	lda (sp),y
	sta $4700 +  #$3d
	ldy #62
	lda (sp),y
	sta $4700 +  #$3e
	ldy #63
	lda (sp),y
	sta $4700 +  #$3f
	ldy #64
	lda (sp),y
	sta $4700 +  #$40
	ldy #65
	lda (sp),y
	sta $4700 +  #$41
	ldy #66
	lda (sp),y
	sta $4700 +  #$42
	ldy #67
	lda (sp),y
	sta $4700 +  #$43
	ldy #68
	lda (sp),y
	sta $4700 +  #$44
	ldy #69
	lda (sp),y
	sta $4700 +  #$45
	ldy #70
	lda (sp),y
	sta $4700 +  #$46
	ldy #71
	lda (sp),y
	sta $4700 +  #$47
	ldy #72
	lda (sp),y
	sta $4700 +  #$48
	ldy #73
	lda (sp),y
	sta $4700 +  #$49
	ldy #74
	lda (sp),y
	sta $4700 +  #$4a
	ldy #75
	lda (sp),y
	sta $4700 +  #$4b
	ldy #76
	lda (sp),y
	sta $4700 +  #$4c
	ldy #77
	lda (sp),y
	sta $4700 +  #$4d
	ldy #78
	lda (sp),y
	sta $4700 +  #$4e
	ldy #79
	lda (sp),y
	sta $4700 +  #$4f
	ldy #80
	lda (sp),y
	sta $4700 +  #$50
	ldy #81
	lda (sp),y
	sta $4700 +  #$51
	ldy #82
	lda (sp),y
	sta $4700 +  #$52
	ldy #83
	lda (sp),y
	sta $4700 +  #$53
	ldy #84
	lda (sp),y
	sta $4700 +  #$54
	ldy #85
	lda (sp),y
	sta $4700 +  #$55
	ldy #86
	lda (sp),y
	sta $4700 +  #$56
	ldy #87
	lda (sp),y
	sta $4700 +  #$57
	ldy #88
	lda (sp),y
	sta $4700 +  #$58
	ldy #89
	lda (sp),y
	sta $4700 +  #$59
	ldy #90
	lda (sp),y
	sta $4700 +  #$5a
	ldy #91
	lda (sp),y
	sta $4700 +  #$5b
	ldy #92
	lda (sp),y
	sta $4700 +  #$5c
	ldy #93
	lda (sp),y
	sta $4700 +  #$5d
	ldy #94
	lda (sp),y
	sta $4700 +  #$5e
	ldy #95
	lda (sp),y
	sta $4700 +  #$5f
	ldy #96
	lda (sp),y
	sta $4700 +  #$60
	ldy #97
	lda (sp),y
	sta $4700 +  #$61
	ldy #98
	lda (sp),y
	sta $4700 +  #$62
	ldy #99
	lda (sp),y
	sta $4700 +  #$63
	ldy #100
	lda (sp),y
	sta $4700 +  #$64
	ldy #101
	lda (sp),y
	sta $4700 +  #$65
	ldy #102
	lda (sp),y
	sta $4700 +  #$66
	ldy #103
	lda (sp),y
	sta $4700 +  #$67
	ldy #104
	lda (sp),y
	sta $4700 +  #$68
	ldy #105
	lda (sp),y
	sta $4700 +  #$69
	ldy #106
	lda (sp),y
	sta $4700 +  #$6a
	ldy #107
	lda (sp),y
	sta $4700 +  #$6b
	ldy #108
	lda (sp),y
	sta $4700 +  #$6c
	ldy #109
	lda (sp),y
	sta $4700 +  #$6d
	ldy #110
	lda (sp),y
	sta $4700 +  #$6e
	ldy #111
	lda (sp),y
	sta $4700 +  #$6f
	ldy #112
	lda (sp),y
	sta $4700 +  #$70
	ldy #113
	lda (sp),y
	sta $4700 +  #$71
	ldy #114
	lda (sp),y
	sta $4700 +  #$72
	ldy #115
	lda (sp),y
	sta $4700 +  #$73
	ldy #116
	lda (sp),y
	sta $4700 +  #$74
	ldy #117
	lda (sp),y
	sta $4700 +  #$75
	ldy #118
	lda (sp),y
	sta $4700 +  #$76
	ldy #119
	lda (sp),y
	sta $4700 +  #$77
	ldy #120
	lda (sp),y
	sta $4700 +  #$78
	ldy #121
	lda (sp),y
	sta $4700 +  #$79
	ldy #122
	lda (sp),y
	sta $4700 +  #$7a
	ldy #123
	lda (sp),y
	sta $4700 +  #$7b
	ldy #124
	lda (sp),y
	sta $4700 +  #$7c
	ldy #125
	lda (sp),y
	sta $4700 +  #$7d
	ldy #126
	lda (sp),y
	sta $4700 +  #$7e
	ldy #127
	lda (sp),y
	sta $4700 +  #$7f
	ldy #128
	lda (sp),y
	sta $4700 +  #$80
	ldy #129
	lda (sp),y
	sta $4700 +  #$81
	ldy #130
	lda (sp),y
	sta $4700 +  #$82
	ldy #131
	lda (sp),y
	sta $4700 +  #$83
	ldy #132
	lda (sp),y
	sta $4700 +  #$84
	ldy #133
	lda (sp),y
	sta $4700 +  #$85
	ldy #134
	lda (sp),y
	sta $4700 +  #$86
	ldy #135
	lda (sp),y
	sta $4700 +  #$87
	ldy #136
	lda (sp),y
	sta $4700 +  #$88
	ldy #137
	lda (sp),y
	sta $4700 +  #$89
	ldy #138
	lda (sp),y
	sta $4700 +  #$8a
	ldy #139
	lda (sp),y
	sta $4700 +  #$8b
	ldy #140
	lda (sp),y
	sta $4700 +  #$8c
	ldy #141
	lda (sp),y
	sta $4700 +  #$8d
	ldy #142
	lda (sp),y
	sta $4700 +  #$8e
	ldy #143
	lda (sp),y
	sta $4700 +  #$8f
	ldy #144
	lda (sp),y
	sta $4700 +  #$90
	ldy #145
	lda (sp),y
	sta $4700 +  #$91
	ldy #146
	lda (sp),y
	sta $4700 +  #$92
	ldy #147
	lda (sp),y
	sta $4700 +  #$93
	ldy #148
	lda (sp),y
	sta $4700 +  #$94
	ldy #149
	lda (sp),y
	sta $4700 +  #$95
	ldy #150
	lda (sp),y
	sta $4700 +  #$96
	ldy #151
	lda (sp),y
	sta $4700 +  #$97
	ldy #152
	lda (sp),y
	sta $4700 +  #$98
	ldy #153
	lda (sp),y
	sta $4700 +  #$99
	ldy #154
	lda (sp),y
	sta $4700 +  #$9a
	ldy #155
	lda (sp),y
	sta $4700 +  #$9b
	ldy #156
	lda (sp),y
	sta $4700 +  #$9c
	ldy #157
	lda (sp),y
	sta $4700 +  #$9d
	ldy #158
	lda (sp),y
	sta $4700 +  #$9e
	ldy #159
	lda (sp),y
	sta $4700 +  #$9f
	ldy #160
	lda (sp),y
	sta $4700 +  #$a0
	ldy #161
	lda (sp),y
	sta $4700 +  #$a1
	ldy #162
	lda (sp),y
	sta $4700 +  #$a2
	ldy #163
	lda (sp),y
	sta $4700 +  #$a3
	ldy #164
	lda (sp),y
	sta $4700 +  #$a4
	ldy #165
	lda (sp),y
	sta $4700 +  #$a5
	ldy #166
	lda (sp),y
	sta $4700 +  #$a6
	ldy #167
	lda (sp),y
	sta $4700 +  #$a7
	ldy #168
	lda (sp),y
	sta $4700 +  #$a8
	ldy #169
	lda (sp),y
	sta $4700 +  #$a9
	ldy #170
	lda (sp),y
	sta $4700 +  #$aa
	ldy #171
	lda (sp),y
	sta $4700 +  #$ab
	ldy #172
	lda (sp),y
	sta $4700 +  #$ac
	ldy #173
	lda (sp),y
	sta $4700 +  #$ad
	ldy #174
	lda (sp),y
	sta $4700 +  #$ae
	ldy #175
	lda (sp),y
	sta $4700 +  #$af
	ldy #176
	lda (sp),y
	sta $4700 +  #$b0
	ldy #177
	lda (sp),y
	sta $4700 +  #$b1
	ldy #178
	lda (sp),y
	sta $4700 +  #$b2
	ldy #179
	lda (sp),y
	sta $4700 +  #$b3
	ldy #180
	lda (sp),y
	sta $4700 +  #$b4
	ldy #181
	lda (sp),y
	sta $4700 +  #$b5
	ldy #182
	lda (sp),y
	sta $4700 +  #$b6
	ldy #183
	lda (sp),y
	sta $4700 +  #$b7
	ldy #184
	lda (sp),y
	sta $4700 +  #$b8
	ldy #185
	lda (sp),y
	sta $4700 +  #$b9
	ldy #186
	lda (sp),y
	sta $4700 +  #$ba
	ldy #187
	lda (sp),y
	sta $4700 +  #$bb
	ldy #188
	lda (sp),y
	sta $4700 +  #$bc
	ldy #189
	lda (sp),y
	sta $4700 +  #$bd
	ldy #190
	lda (sp),y
	sta $4700 +  #$be
	ldy #191
	lda (sp),y
	sta $4700 +  #$bf
	ldy #192
	lda (sp),y
	sta $4700 +  #$c0
	ldy #193
	lda (sp),y
	sta $4700 +  #$c1
	ldy #194
	lda (sp),y
	sta $4700 +  #$c2
	ldy #195
	lda (sp),y
	sta $4700 +  #$c3
	ldy #196
	lda (sp),y
	sta $4700 +  #$c4
	ldy #197
	lda (sp),y
	sta $4700 +  #$c5
	ldy #198
	lda (sp),y
	sta $4700 +  #$c6
	ldy #199
	lda (sp),y
	sta $4700 +  #$c7
	ldy #200
	lda (sp),y
	sta $4700 +  #$c8
	ldy #201
	lda (sp),y
	sta $4700 +  #$c9
	ldy #202
	lda (sp),y
	sta $4700 +  #$ca
	ldy #203
	lda (sp),y
	sta $4700 +  #$cb
	ldy #204
	lda (sp),y
	sta $4700 +  #$cc
	ldy #205
	lda (sp),y
	sta $4700 +  #$cd
	ldy #206
	lda (sp),y
	sta $4700 +  #$ce
	ldy #207
	lda (sp),y
	sta $4700 +  #$cf
	ldy #208
	lda (sp),y
	sta $4700 +  #$d0
	ldy #209
	lda (sp),y
	sta $4700 +  #$d1
	ldy #210
	lda (sp),y
	sta $4700 +  #$d2
	ldy #211
	lda (sp),y
	sta $4700 +  #$d3
	ldy #212
	lda (sp),y
	sta $4700 +  #$d4
	ldy #213
	lda (sp),y
	sta $4700 +  #$d5
	ldy #214
	lda (sp),y
	sta $4700 +  #$d6
	ldy #215
	lda (sp),y
	sta $4700 +  #$d7
	ldy #216
	lda (sp),y
	sta $4700 +  #$d8
	ldy #217
	lda (sp),y
	sta $4700 +  #$d9
	ldy #218
	lda (sp),y
	sta $4700 +  #$da
	ldy #219
	lda (sp),y
	sta $4700 +  #$db
	ldy #220
	lda (sp),y
	sta $4700 +  #$dc
	ldy #221
	lda (sp),y
	sta $4700 +  #$dd
	ldy #222
	lda (sp),y
	sta $4700 +  #$de
	ldy #223
	lda (sp),y
	sta $4700 +  #$df
	ldy #224
	lda (sp),y
	sta $4700 +  #$e0
	ldy #225
	lda (sp),y
	sta $4700 +  #$e1
	ldy #226
	lda (sp),y
	sta $4700 +  #$e2
	ldy #227
	lda (sp),y
	sta $4700 +  #$e3
	ldy #228
	lda (sp),y
	sta $4700 +  #$e4
	ldy #229
	lda (sp),y
	sta $4700 +  #$e5
	ldy #230
	lda (sp),y
	sta $4700 +  #$e6
	ldy #231
	lda (sp),y
	sta $4700 +  #$e7
	; Assigning single variable : sp
	; WORD optimization: a=a+b
	lda sp+0
	
	clc
	adc #232
	bcc UpdateFrame_WordAdd28
	inc sp+1
UpdateFrame_WordAdd28
	sta sp+0
	
; // Add upp to 40x25 = 1000
	inc frame
	; Binary clause Simplified: EQUALS
	lda frame
	; Compare with pure num / var optimization
	cmp #$8;keep
	bne UpdateFrame_elsedoneblock33
UpdateFrame_ConditionalTrueBlock31
	
; // Reset frame
	; Assigning single variable : frame
	lda #0
	sta frame
	; Assigning single variable : sp
	lda #<screens1
	ldx #>screens1
	sta sp
	stx sp+1
UpdateFrame_elseblock32
UpdateFrame_elsedoneblock33
	rts
	
; // Simple raster routine
EndBlock12
